Index: platform/ixusizoom_sd30/sub/100g/makefile.inc.new
===================================================================
--- platform/ixusizoom_sd30/sub/100g/makefile.inc.new	(Revision 0)
+++ platform/ixusizoom_sd30/sub/100g/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/ixusizoom_sd30/makefile.inc.new
===================================================================
--- platform/ixusizoom_sd30/makefile.inc.new	(Revision 0)
+++ platform/ixusizoom_sd30/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/ixus750_sd550/sub/100f/makefile.inc.new
===================================================================
--- platform/ixus750_sd550/sub/100f/makefile.inc.new	(Revision 0)
+++ platform/ixus750_sd550/sub/100f/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/ixus750_sd550/sub/100g/makefile.inc.new
===================================================================
--- platform/ixus750_sd550/sub/100g/makefile.inc.new	(Revision 0)
+++ platform/ixus750_sd550/sub/100g/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/ixus750_sd550/makefile.inc.new
===================================================================
--- platform/ixus750_sd550/makefile.inc.new	(Revision 0)
+++ platform/ixus750_sd550/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/a610/sub/100e/makefile.inc.new
===================================================================
--- platform/a610/sub/100e/makefile.inc.new	(Revision 0)
+++ platform/a610/sub/100e/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a610/sub/100f/makefile.inc.new
===================================================================
--- platform/a610/sub/100f/makefile.inc.new	(Revision 0)
+++ platform/a610/sub/100f/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a610/makefile.inc.new
===================================================================
--- platform/a610/makefile.inc.new	(Revision 0)
+++ platform/a610/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/ixus50_sd400/sub/101a/makefile.inc.new
===================================================================
--- platform/ixus50_sd400/sub/101a/makefile.inc.new	(Revision 0)
+++ platform/ixus50_sd400/sub/101a/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/ixus50_sd400/sub/101b/makefile.inc.new
===================================================================
--- platform/ixus50_sd400/sub/101b/makefile.inc.new	(Revision 0)
+++ platform/ixus50_sd400/sub/101b/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/ixus50_sd400/makefile.inc.new
===================================================================
--- platform/ixus50_sd400/makefile.inc.new	(Revision 0)
+++ platform/ixus50_sd400/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/sx100is/sub/100b/boot.c
===================================================================
--- platform/sx100is/sub/100b/boot.c	(Revision 701)
+++ platform/sx100is/sub/100b/boot.c	(Arbeitskopie)
@@ -101,6 +101,7 @@
 		 "BCC	loc_FFC00200\n"
 
 		 "BL	sub_FFC00FB8_my\n"				// <----------
+		 ".pool\n" // needed for gcc 4.x
 	);
 } //#fe
 
@@ -156,6 +157,7 @@
 		 "BL	sub_FFC02D70\n"
 		 "ADD	SP, SP,	#0x74\n"
 		 "LDR	PC, [SP],#4\n"
+		 ".pool\n" // needed for gcc 4.x
 	);
 }; //#fe
 
Index: platform/sx100is/sub/100b/makefile.inc.new
===================================================================
--- platform/sx100is/sub/100b/makefile.inc.new	(Revision 0)
+++ platform/sx100is/sub/100b/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/sx100is/sub/100c/boot.c
===================================================================
--- platform/sx100is/sub/100c/boot.c	(Revision 701)
+++ platform/sx100is/sub/100c/boot.c	(Arbeitskopie)
@@ -101,6 +101,7 @@
 		 "BCC	loc_FFC00200\n"
 
 		 "BL	sub_FFC00FB8_my\n"				// <----------
+		 ".pool\n"
 	);
 } //#fe
 
@@ -156,6 +157,7 @@
 		 "BL	sub_FFC02D70\n"
 		 "ADD	SP, SP,	#0x74\n"
 		 "LDR	PC, [SP],#4\n"
+		 ".pool\n"
 	);
 }; //#fe
 
Index: platform/sx100is/sub/100c/makefile.inc.new
===================================================================
--- platform/sx100is/sub/100c/makefile.inc.new	(Revision 0)
+++ platform/sx100is/sub/100c/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/sx100is/makefile.inc.new
===================================================================
--- platform/sx100is/makefile.inc.new	(Revision 0)
+++ platform/sx100is/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/a710/sub/100a/makefile.inc.new
===================================================================
--- platform/a710/sub/100a/makefile.inc.new	(Revision 0)
+++ platform/a710/sub/100a/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a710/makefile.inc.new
===================================================================
--- platform/a710/makefile.inc.new	(Revision 0)
+++ platform/a710/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/a530/sub/100a/makefile.inc.new
===================================================================
--- platform/a530/sub/100a/makefile.inc.new	(Revision 0)
+++ platform/a530/sub/100a/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a530/makefile.inc.new
===================================================================
--- platform/a530/makefile.inc.new	(Revision 0)
+++ platform/a530/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/a450/sub/100d/makefile.inc.new
===================================================================
--- platform/a450/sub/100d/makefile.inc.new	(Revision 0)
+++ platform/a450/sub/100d/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a450/makefile.inc.new
===================================================================
--- platform/a450/makefile.inc.new	(Revision 0)
+++ platform/a450/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/ixus950_sd850/main.c
===================================================================
--- platform/ixus950_sd850/main.c	(Revision 701)
+++ platform/ixus950_sd850/main.c	(Arbeitskopie)
@@ -25,13 +25,13 @@
 
 int get_focal_length(int zp) {
     if (zp<0) return fl_tbl[0];
-    else if (zp>NUM_FL-1) return fl_tbl[NUM_FL-1];
+    else if (zp>(int)NUM_FL-1) return fl_tbl[NUM_FL-1];
     else return fl_tbl[zp];
 }
 
 int get_zoom_x(int zp) {
     if (zp<1) return 10;
-    else if (zp>NUM_FL-1) return fl_tbl[NUM_FL-1]*10/fl_tbl[0];
+    else if (zp>(int)NUM_FL-1) return fl_tbl[NUM_FL-1]*10/fl_tbl[0];
     else return fl_tbl[zp]*10/fl_tbl[0];
 }
 
@@ -68,7 +68,8 @@
 #define MODESCNT (sizeof(modemap)/sizeof(modemap[0]))
 
 int mode_get() {
-    int mode, i, t=0xFF;
+    unsigned i;
+    int mode, t=0xFF;
 
     mode  = (physw_status[2] & 0x1000)?MODE_REC:MODE_PLAY;    
     _GetPropertyCase(49, &t, 4);
Index: platform/ixus950_sd850/sub/100c/stubs_entry_2.S
===================================================================
--- platform/ixus950_sd850/sub/100c/stubs_entry_2.S	(Revision 701)
+++ platform/ixus950_sd850/sub/100c/stubs_entry_2.S	(Arbeitskopie)
@@ -57,7 +57,11 @@
 NHSTUB(GetOpticalTemperature, 0xFFA3D3E0)
 NHSTUB(PT_PlaySound, 0xFFB1A0A4)
 NHSTUB(taskNameToId, 0xFF935A64)
-
+// those are mainly to play around with them for me and to figure out how time
+// related functions work on my cam
+NHSTUB(getenv,0xFF9263C0)
+NHSTUB(putenv,0xFF92641C)
+NSTUB(localtime_r, 0xff924788)
 //NHSTUB(EnterToCompensationEVF, 0xFFFFFFFF) // Stub not found. When found, remove dummy function from lib.c.
 //NHSTUB(ExitFromCompensationEVF, 0xFFFFFFFF) // Stub not found. When found, remove dummy function from lib.c.
 NHSTUB(DoAFLock, 0xffb09200)
Index: platform/ixus950_sd850/sub/100c/makefile.inc.new
===================================================================
--- platform/ixus950_sd850/sub/100c/makefile.inc.new	(Revision 0)
+++ platform/ixus950_sd850/sub/100c/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/ixus950_sd850/shooting.c
===================================================================
--- platform/ixus950_sd850/shooting.c	(Revision 701)
+++ platform/ixus950_sd850/shooting.c	(Arbeitskopie)
@@ -118,7 +118,7 @@
 char* shooting_get_tv_str()
 {
     short int tvv;
-    long i;
+    unsigned i;
 //    _GetPropertyCase(69, &tvv, sizeof(tvv));
 //    _GetPropertyCase(262, &tvv, sizeof(tvv));
     _GetPropertyCase(PROPCASE_TV, &tvv, sizeof(tvv));	// 262 for DiGiC III
@@ -132,7 +132,7 @@
 char* shooting_get_av_str()
 {
     short int avv;
-    long i;
+    unsigned i;
 //    _GetPropertyCase(68, &avv, sizeof(avv));
 //    _GetPropertyCase(23, &avv, sizeof(avv));
     _GetPropertyCase(PROPCASE_AV, &avv, sizeof(avv));	// 23 for DiGiC III
@@ -146,7 +146,7 @@
 char* shooting_get_iso_str()
 {
     short int isov;
-    long i;
+    unsigned i;
     _GetPropertyCase(PROPCASE_ISO_MODE, &isov, sizeof(isov));
     for (i=0;i<ISO_SIZE;i++){
    if (iso_table[i].prop_id == isov)
Index: platform/ixus950_sd850/makefile.inc.new
===================================================================
--- platform/ixus950_sd850/makefile.inc.new	(Revision 0)
+++ platform/ixus950_sd850/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/a630/sub/100c/makefile.inc.new
===================================================================
--- platform/a630/sub/100c/makefile.inc.new	(Revision 0)
+++ platform/a630/sub/100c/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a630/makefile.inc.new
===================================================================
--- platform/a630/makefile.inc.new	(Revision 0)
+++ platform/a630/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/makefile_generic.inc.new
===================================================================
--- platform/makefile_generic.inc.new	(Revision 0)
+++ platform/makefile_generic.inc.new	(Revision 0)
@@ -0,0 +1,25 @@
+
+
+LOCAL_CFLAGS:=-DLOW_LEVEL
+
+SUBDIRS=sub
+
+C_OBJS := main.o lib.o wrappers.o kbd.o shooting.o $(EXTRA_C_OBJS)
+ASM_OBJS := $(EXTRA_ASM_OBJS)
+OBJS := $(C_OBJS) $(ASM_OBJS)
+
+# stubs_init.o
+OBJS := $(call subdirize,$(OBJS) )
+C_OBJS := $(call subdirize,$(C_OBJS) )
+ASM_OBJS := $(call subdirize,$(ASM_OBJS) )
+
+$(eval $(call compile-targets, $(C_OBJS), $(LOCAL_CFLAGS) ) )
+$(eval $(call compile-asm-targets, $(ASM_OBJS), $(LOCAL_CFLAGS) ) )
+
+$(eval $(call ar-targets, libplatform.a, $(OBJS), ))
+
+$(eval $(call gen-rule, $(PLATFORM)-platform-clean,, rm -f $(OBJS) $(subdir)/*.$(DEPSUFFIX) $(subdir)/sub/$(PLATFORMSUB)/*.$(DEPSUFFIX) $(subdir)/libplatform.a ))
+
+$(PLATFORM)-platform-distclean: $(PLATFORM)-platform-clean
+
+# vim: ft=make
Index: platform/a550/sub/100c/makefile.inc.new
===================================================================
--- platform/a550/sub/100c/makefile.inc.new	(Revision 0)
+++ platform/a550/sub/100c/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a550/makefile.inc.new
===================================================================
--- platform/a550/makefile.inc.new	(Revision 0)
+++ platform/a550/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/a650/sub/100d/makefile.inc.new
===================================================================
--- platform/a650/sub/100d/makefile.inc.new	(Revision 0)
+++ platform/a650/sub/100d/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a650/makefile.inc.new
===================================================================
--- platform/a650/makefile.inc.new	(Revision 0)
+++ platform/a650/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/generic/wrappers.c
===================================================================
--- platform/generic/wrappers.c	(Revision 701)
+++ platform/generic/wrappers.c	(Arbeitskopie)
@@ -792,6 +792,62 @@
  return 0;
 }
 
+void reverse_bytes_order_target(char* start, int count, char* dest) {
+// note, we will go to count rounded up to the nearest 32
+asm volatile(
+	"ldr	r3, =0xFF00FF\n"	// r3 = mask
+	"add	r1, r0, r1\n"		// r1 = start + count
+"LOOPB:\n"
+	"ldm	r0, {R4-R11}\n"		// load 8 words
+	
+	// out = ((in>>8) & 0xFF00FF) | ((in&0xFF00FF) << 8);
+	"mov	r12, r4, lsr #8\n"	// r12 = in >> 8
+	"and	r12, r12, r3\n"		// r12 &= 0xFF00FF
+	"and	r4, r4, r3\n"		// r4 = in & 0xFF00FF
+	"orr	r4, r12, r4, asl #8\n" // out = r12 | (r4 << 8)
+
+	"mov	r12, r5, lsr #8\n"
+	"and	r12, r12, r3\n"
+	"and	r5, r5, r3\n"
+	"orr	r5, r12, r5, asl #8\n"
+
+	"mov	r12, r6, lsr #8\n"
+	"and	r12, r12, r3\n"
+	"and	r6, r6, r3\n"
+	"orr	r6, r12, r6, asl #8\n"
+
+	"mov	r12, r7, lsr #8\n"
+	"and	r12, r12, r3\n"
+	"and	r7, r7, r3\n"
+	"orr	r7, r12, r7, asl #8\n"
+
+	"mov	r12, r8, lsr #8\n"
+	"and	r12, r12, r3\n"
+	"and	r8, r8, r3\n"
+	"orr	r8, r12, r8, asl #8\n"
+
+	"mov	r12, r9, lsr #8\n"
+	"and	r12, r12, r3\n"
+	"and	r9, r9, r3\n"
+	"orr	r9, r12, r9, asl #8\n"
+
+	"mov	r12, r10, lsr #8\n"
+	"and	r12, r12, r3\n"
+	"and	r10, r10, r3\n"
+	"orr	r10, r12, r10, asl #8\n"
+
+	"mov	r12, r11, lsr #8\n"
+	"and	r12, r12, r3\n"
+	"and	r11, r11, r3\n"
+	"orr	r11, r12, r11, asl #8\n"
+
+	"stmia	r2!, {r4-r11}\n"	// store and increment
+
+	"cmp	r0, r1\n"
+	"bcc	LOOPB\n"
+	:::"r0","r1","r2","r3","r4","r5","r6","r7","r8","r9","r10","r11","r12"
+ );
+}
 void reverse_bytes_order(char* start, int count){
 // note, we will go to count rounded up to the nearest 32
 asm volatile(
Index: platform/generic/shooting.c
===================================================================
--- platform/generic/shooting.c	(Revision 701)
+++ platform/generic/shooting.c	(Arbeitskopie)
@@ -110,7 +110,7 @@
 const ShutterSpeed *shooting_get_tv_line()
 {
     short tvv;
-    long i;
+    unsigned i;
     _GetPropertyCase(PROPCASE_USER_TV, &tvv, sizeof(tvv));
     for (i=0;i<SS_SIZE;i++){
 	   if (shutter_speeds_table[i].prop_id == tvv)
@@ -123,7 +123,7 @@
 {
 #if CAM_HAS_USER_TV_MODES
 if ((mode_get()&MODE_MASK) != MODE_PLAY){
-    long i;
+    unsigned i;
 //    if ((v<SSID_MIN) || (v>SSID_MAX))
 //	return;
  for (i=0;i<SS_SIZE;i++){
@@ -162,7 +162,7 @@
 int shooting_get_iso_mode()
 {
     short isov;
-    long i;
+    unsigned i;
     _GetPropertyCase(PROPCASE_ISO_MODE, &isov, sizeof(isov));
     for (i=0;i<ISO_SIZE;i++){
 			if (iso_table[i].prop_id == isov)
@@ -564,7 +564,7 @@
 
 void shooting_set_tv96(short v, short is_now)
 {
- long i;
+    unsigned i;
 //    if ((v<SSID_MIN) || (v>SSID_MAX))
 //	return;
 if ((mode_get()&MODE_MASK) != MODE_PLAY){
@@ -820,7 +820,7 @@
 
 void shooting_set_iso_mode(int v)
 {
- long i;
+ unsigned i;
  for (i=0;i<ISO_SIZE;i++){
 	if (iso_table[i].id == v){
 	    short vv = iso_table[i].prop_id;
@@ -980,7 +980,7 @@
 
 void shooting_video_bitrate_change(int v){
  int m[]={1,2,3,4,5,6,7,8,10,12};  // m[v]/4 = bitrate*1x
- if (v>=(sizeof(m)/sizeof(m[0]))) v=(sizeof(m)/sizeof(m[0]))-1;
+ if ((unsigned)v>=(sizeof(m)/sizeof(m[0]))) v=(sizeof(m)/sizeof(m[0]))-1;
 #if CAM_CHDK_HAS_EXT_VIDEO_MENU
  change_video_tables(m[v],4);
 #endif
@@ -1022,7 +1022,7 @@
 
 short shooting_get_av96_override_value()
 {
-  if (conf.av_override_value<=AS_SIZE)	return (short) aperture_sizes_table[conf.av_override_value-1].prop_id;
+  if ((unsigned)conf.av_override_value<=AS_SIZE)	return (short) aperture_sizes_table[conf.av_override_value-1].prop_id;
   else return (short) (AV96_MAX+32*(conf.av_override_value-AS_SIZE));
 }
 
Index: platform/generic/makefile.inc.new
===================================================================
--- platform/generic/makefile.inc.new	(Revision 0)
+++ platform/generic/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/a570/sub/101a/makefile.inc.new
===================================================================
--- platform/a570/sub/101a/makefile.inc.new	(Revision 0)
+++ platform/a570/sub/101a/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a570/sub/100e/makefile.inc.new
===================================================================
--- platform/a570/sub/100e/makefile.inc.new	(Revision 0)
+++ platform/a570/sub/100e/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a570/makefile.inc.new
===================================================================
--- platform/a570/makefile.inc.new	(Revision 0)
+++ platform/a570/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/g7/sub/100e/makefile.inc.new
===================================================================
--- platform/g7/sub/100e/makefile.inc.new	(Revision 0)
+++ platform/g7/sub/100e/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/g7/sub/100g/makefile.inc.new
===================================================================
--- platform/g7/sub/100g/makefile.inc.new	(Revision 0)
+++ platform/g7/sub/100g/makefile.inc.new	(Revision 0)
@@ -0,0 +1,7 @@
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/g7/sub/100i/makefile.inc.new
===================================================================
--- platform/g7/sub/100i/makefile.inc.new	(Revision 0)
+++ platform/g7/sub/100i/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/g7/sub/100j/makefile.inc.new
===================================================================
--- platform/g7/sub/100j/makefile.inc.new	(Revision 0)
+++ platform/g7/sub/100j/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/g7/makefile.inc.new
===================================================================
--- platform/g7/makefile.inc.new	(Revision 0)
+++ platform/g7/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/makefile.inc.new
===================================================================
--- platform/makefile.inc.new	(Revision 0)
+++ platform/makefile.inc.new	(Revision 0)
@@ -0,0 +1,13 @@
+
+LOCAL_SUBDIRS := $(PLATFORM)
+LOCAL_SUBSUBDIRS := $(subdir)/$(PLATFORM)/sub/$(PLATFORMSUB)
+
+$(eval $(call gen-rule, platform-clean, $(foreach lsub,$(LOCAL_SUBDIRS),sub-platform-clean), ))
+
+$(eval $(call gen-rule, platform-distclean, $(foreach lsub,$(LOCAL_SUBDIRS),sub-platform-distclean), ))
+LOCAL_SUBDIRS:=$(call subdirize,$(LOCAL_SUBDIRS) )
+
+$(foreach subdir,$(LOCAL_SUBDIRS),$(eval include $(subdir)/makefile.inc.new) )
+$(foreach subdir,$(LOCAL_SUBSUBDIRS),$(eval include $(subdir)/makefile.inc.new) )
+
+# vim: ft=make
Index: platform/a590/sub/101b/makefile.inc.new
===================================================================
--- platform/a590/sub/101b/makefile.inc.new	(Revision 0)
+++ platform/a590/sub/101b/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a590/sub/100e/makefile.inc.new
===================================================================
--- platform/a590/sub/100e/makefile.inc.new	(Revision 0)
+++ platform/a590/sub/100e/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a590/makefile.inc.new
===================================================================
--- platform/a590/makefile.inc.new	(Revision 0)
+++ platform/a590/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: makefile.inc
===================================================================
--- makefile.inc	(Revision 701)
+++ makefile.inc	(Arbeitskopie)
@@ -368,5 +368,5 @@
 	done
 
 ifdef SILENT
-.SILENT:
+
 endif
Index: core/gui_sokoban.c
===================================================================
--- core/gui_sokoban.c	(Revision 701)
+++ core/gui_sokoban.c	(Arbeitskopie)
@@ -214,7 +214,7 @@
 
 //-------------------------------------------------------------------
 static void sokoban_next_level() {
-    if (++conf.sokoban_level >= num_levels) conf.sokoban_level = 0;
+    if ((unsigned)(++conf.sokoban_level) >= num_levels) conf.sokoban_level = 0;
     sokoban_set_level(conf.sokoban_level);
     need_redraw = 1;
 }
@@ -313,7 +313,7 @@
     if(!num_levels) {
         return 0;
     }
-    else if(conf.sokoban_level >= num_levels) {
+    else if((unsigned)conf.sokoban_level >= num_levels) {
         conf.sokoban_level = 0;
     }
     cell_size = screen_height/FIELD_HEIGHT;
Index: core/script.c
===================================================================
--- core/script.c	(Revision 701)
+++ core/script.c	(Arbeitskopie)
@@ -82,7 +82,7 @@
 //-------------------------------------------------------------------
 static void process_title(const char *title) {
     register const char *ptr = title;
-    register int i=0;
+    register unsigned int i=0;
 
     while (ptr[0]==' ' || ptr[0]=='\t') ++ptr; // whitespaces
     while (i<(sizeof(script_title)-1) && ptr[i] && ptr[i]!='\r' && ptr[i]!='\n') {
@@ -95,7 +95,7 @@
 //-------------------------------------------------------------------
 static int process_param(const char *param, int update) {
     register const char *ptr = param;
-    register int n, i=0;
+    register unsigned int n, i=0;
 
     while (ptr[0]==' ' || ptr[0]=='\t') ++ptr; // whitespaces
     if (ptr[0] && (ptr[0]>='a' && ptr[0]<='a'+SCRIPT_NUM_PARAMS) && (ptr[1]==' ' || ptr[1]=='\t')) {
Index: core/raw_merge.c
===================================================================
--- core/raw_merge.c	(Revision 701)
+++ core/raw_merge.c	(Arbeitskopie)
@@ -48,10 +48,10 @@
 
     struct stat st;
 
-    if (stat((char *)from,&st) != 0 || st.st_size!=hook_raw_size()) 
+    if (stat((char *)from,&st) != 0 || (long)st.st_size!=hook_raw_size()) 
         return 0;
 
-    if (stat((char *)sub,&st) != 0 || st.st_size!=hook_raw_size()) 
+    if (stat((char *)sub,&st) != 0 || (long)st.st_size!=hook_raw_size()) 
         return 0;
 
      if( (baccum=malloc(RAW_ROWLEN)) &&
@@ -171,7 +171,7 @@
     return;
 
   stat(filename,&st);
-  if (st.st_size!=hook_raw_size())
+  if ((long)st.st_size!=hook_raw_size())
     return;
 
   started();
Index: core/dng.c
===================================================================
--- core/dng.c	(Revision 701)
+++ core/dng.c	(Arbeitskopie)
@@ -383,6 +383,17 @@
  cam_AsShotNeutral[1]=wb[1];
  cam_AsShotNeutral[3]=wb[0];
  cam_AsShotNeutral[5]=wb[2];
+
+	FILE *cfd;
+
+	cfd = fopen("A/CHDK/propdump","wb");
+	const char* start = (const char*)0x2cb148;
+	start += 0x580;
+	int len = 32*280; // space for all of them?
+	fwrite(start,len,1,cfd);
+	fclose(cfd);
+
+
  return &data;
 }
 
Index: core/conf.c
===================================================================
--- core/conf.c	(Revision 701)
+++ core/conf.c	(Arbeitskopie)
@@ -52,8 +52,8 @@
 
 // reyalp: putting these in conf, since the conf values are lookups for them
 // prefixes and extentions available for raw images (index with conf.raw_prefix etc)
-const char* img_prefixes[NUM_IMG_PREFIXES]={ "IMG_", "CRW_", "SND_" /*, "AUT_", "ETC_","SDR_", "MVI_", "MRK_"*/};
-const char* img_exts[NUM_IMG_EXTS]={ ".JPG", ".CRW", ".CR2", ".THM", ".WAV"/*, ".AVI", ".MRK"*/};
+const char* img_prefixes[NUM_IMG_PREFIXES]={ "IMG_", "CRW_", "SND_", "crw_" , "AUT_", "ETC_","SDR_", "MVI_", "MRK_"};
+const char* img_exts[NUM_IMG_EXTS]={ ".JPG", ".CRW", ".CR2", ".THM", ".WAV", ".AVI", ".MRK", ".DNG" };
 // ugh
 const char *video_bitrate_strings[VIDEO_BITRATE_STEPS]={ "0.25x", "0.5x","0.75x", "1x", "1.25x", "1.5x", "1.75x", "2x", "2.5x", "3x"};
 
@@ -508,7 +508,7 @@
 
 //-------------------------------------------------------------------
 void conf_load_defaults() {
-    register int i;
+    register unsigned int i;
 
     for (i=0; i<CONF_NUM; ++i) {
         switch (conf_info[i].type) {
@@ -528,7 +528,7 @@
 //-------------------------------------------------------------------
 void conf_save() {
     static const long t=CONF_MAGICK_VALUE;
-    register int i;
+    register unsigned int i;
     int fd;
     char *buf=umalloc(sizeof(t)+CONF_NUM*(sizeof(conf_info[0].id)+sizeof(conf_info[0].size))+sizeof(conf));
     char *p=buf;
@@ -554,7 +554,8 @@
 
 //-------------------------------------------------------------------
 void conf_restore() {
-    int fd, rcnt, i;
+    unsigned rcnt, i;
+    int fd;
     unsigned short id, size;
     char *buf;
     int offs;
@@ -597,7 +598,7 @@
 
         for (i=0; i<CONF_NUM; ++i) {
             if (conf_info[i].id==id && conf_info[i].size==size) {
-                if (offs + size <= rcnt) {
+                if ((unsigned)(offs + size) <= rcnt) {
                    memcpy(conf_info[i].var, buf+offs, size);
                    if (conf_info[i].func) {
                        conf_info[i].func();
Index: core/gui_lang.c
===================================================================
--- core/gui_lang.c	(Revision 701)
+++ core/gui_lang.c	(Arbeitskopie)
@@ -546,7 +546,6 @@
 "425 \"RAW buffer cached\"\n"
 "426 \"Cannot load CHDK/badpixel.bin\\nPlease run \\nCHDK/SCRIPTS/TEST/badpixel.lua\"\n"
 "427 \"Show saving time\"\n"
-
 "428 \"Connect 4\"\n"
 "429 \"Opponent:\"\n"
 "430 \"Human\"\n"
@@ -575,6 +574,9 @@
 "452 \"Restart Camera...\"\n"
 "453 \"Force manual flash\"\n"
 
+"451 \"Property Compare/Dump\"\n"
+"452 \"Params Compare/Dump\"\n"
+
 ;
 
 //-------------------------------------------------------------------
